MPM(5)

NAME
mpm, mspe - macros for page makeup

SYNOPSIS
troff -mpm [ files]

troff -mspe [ files]

DESCRIPTION
These troff(1) macros, largely compatible with ms(6), make better pages. They silently invoke and provide information to a postprocessor that moves floating figures, avoids widows, and justifies pages vertically by stretching vertical spaces that result from .PP(,) .LP(,) .IP(,) .QP(,) .SH(,) .NH(,) .DS(/).DE .EQ(/).EN .TS(/).TE .PS(/).PE .P1(/).P2 and .QS(/).QE The packages support different styles:

-mpm
    generic

-mspe
    Software—Practice and Experience

The following macros are different from or not part of the MS package. Values denoted n default to 1v(.)
Begin a new page.
Flush: force out previous keeps.
Finish a two-column region and start a new one.
Floating keep, with preferred center at vertical position
    m. Special values (default) and are permitted.
Start new page if remaining vertical space on this page
    is less than n .
Begin a program display (Courier font).
End a program display.
Insert optional break point in program display.
Insert vertical space of height
    n, stretchable unless is present.
Place page number and
    text on the standard error output.
Present
    text to the hidden page-makeup program as part of a device-dependent output sequence text''. Equivalent to

Useful number registers:
    Header margin; default 1 inch.
    Footer margin; default 1 inch.
    Page footer; default 10 inches.
    Page number of current page.
    Shrinkage of point size for
        .P1(,) in points.
    Shrinkage of vertical spacing for
        .P1(,) in points.

Useful strings:
    %e
    Even page title command (as
        .tl ''''().)
        %o
    Odd page title command (as
        .tl ''''().)

BUGS
These features of -ms are missing:
    Document styles other than the default .RP(.)
    Space between front matter and first paragraph. Recover it with .SP 2(.)
    Separating rule above footnotes.
    Keeps assigned to a separate page.
    Pages with more than two columns.
Troff option -o doesn't work with -mpm because only the postprocessor knows the page numbers.

FILES

SEE ALSO
ms(6), troff(1)